//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4A9D59E201C2.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4A9D59E201C2.cm

//## begin module%4A9D59E201C2.cp preserve=no
//## end module%4A9D59E201C2.cp

//## Module: PlotSettings%4A9D59E201C2; Package body
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Plot/PlotSettings.cxx

//## begin module%4A9D59E201C2.additionalIncludes preserve=no
//## end module%4A9D59E201C2.additionalIncludes

//## begin module%4A9D59E201C2.includes preserve=yes
//## end module%4A9D59E201C2.includes

// PlotSettings
#include <XSPlot/Plot/PlotSettings.h>
//## begin module%4A9D59E201C2.declarations preserve=no
//## end module%4A9D59E201C2.declarations

//## begin module%4A9D59E201C2.additionalDeclarations preserve=yes
#include <XSContainer.h>
#include <XSstreams.h>
#include <XSModel/Data/SpectralData.h>
#include <XSModel/GlobalContainer/DataContainer.h>
#include <XSUtil/Error/Error.h>
#include <XSUtil/Parse/XSparse.h>
#include <sstream>
//## end module%4A9D59E201C2.additionalDeclarations


// Class PlotSettings::RebinInfo 

// Class PlotSettings 

PlotSettings::PlotSettings()
  //## begin PlotSettings::PlotSettings%4A9D5A2C005E_const.hasinit preserve=no
  //## end PlotSettings::PlotSettings%4A9D5A2C005E_const.hasinit
  //## begin PlotSettings::PlotSettings%4A9D5A2C005E_const.initialization preserve=yes
  : m_xOption(CHANNELS),
   m_userCommands(),
   m_prevGroupRange(0,0),
   m_temperature(1.0),
   m_emisLimit(1.0e-18),
   m_redshiftLinesToObs(.0),
   m_redshiftToSource(.0),
   m_groupsRebinInfo(),
   m_lastRebinEntry(),
   m_splashPage(true),
   m_xLog(true),
   m_yLog(false),
   m_energyUnit(), // Leave it to PlotDirector to set initial units.
   m_waveUnit(),
   m_isWavePerHz(true),
   m_divideByArea(false,false),
   m_showAddComponent(false,0),
   m_showBackground(false,false),
   m_showLineIDs(false,false),
   m_spectra(),
   m_isInteractive(false),
   m_saveArrayInfo(PlotSettings::NO_SAVE, 1),
   m_labelNames(), // Filled from PlotDirector
   m_badDataValue(.0) // Filled from PlotDirector
  //## end PlotSettings::PlotSettings%4A9D5A2C005E_const.initialization
{
  //## begin PlotSettings::PlotSettings%4A9D5A2C005E_const.body preserve=yes
    RebinInfo initEntry;
    initEntry.sigma = 0; initEntry.maxBins = 1; initEntry.mode = STD;
    m_lastRebinEntry = std::pair<int, RebinInfo>(-1, initEntry);
    m_groupsRebinInfo.insert(m_lastRebinEntry);
  //## end PlotSettings::PlotSettings%4A9D5A2C005E_const.body
}


PlotSettings::~PlotSettings()
{
  //## begin PlotSettings::~PlotSettings%4A9D5A2C005E_dest.body preserve=yes
  //## end PlotSettings::~PlotSettings%4A9D5A2C005E_dest.body
}



//## Other Operations (implementation)
void PlotSettings::setXOption (const string& option)
{
  //## begin PlotSettings::setXOption%4A9D641C03D8.body preserve=yes
  if (option == "channel")
  {
     m_xOption = CHANNELS;
     SpectralData::chanEngWave(0);
  }
  else if (option == "energy")
  {
     m_xOption = ENERGY;
     SpectralData::chanEngWave(1);
  }
  else if (option == "wavelength")
  {
     m_xOption = WAVELENGTH;
     SpectralData::chanEngWave(2);
  }
  else throw RedAlert(" Programmer Error: X-axis mode");
  //## end PlotSettings::setXOption%4A9D641C03D8.body
}

int PlotSettings::addUserCommand (const string& command)
{
  //## begin PlotSettings::addUserCommand%4A9D690702C7.body preserve=yes
  m_userCommands.push_back(command);
  return static_cast<int>(m_userCommands.size());
  //## end PlotSettings::addUserCommand%4A9D690702C7.body
}

void PlotSettings::removeUserCommand (int numCmd)
{
  //## begin PlotSettings::removeUserCommand%4A9D69FF01D7.body preserve=yes
  if (numCmd > static_cast<int>(m_userCommands.size()))
  {
     throw YellowAlert("Command does not exist\n");
  }
  
  std::list<std::string>::iterator iC = m_userCommands.begin();
  
  for (int i=1; i<numCmd; ++i)
  {
     ++iC;
  }
  m_userCommands.erase(iC);  
  //## end PlotSettings::removeUserCommand%4A9D69FF01D7.body
}

void PlotSettings::setPlotGroupNums (const string& rangesString)
{
  //## begin PlotSettings::setPlotGroupNums%4A9D6E0201D8.body preserve=yes
    using namespace XSContainer;
    
    size_t sz (datasets->numberOfSpectra());
    if (!sz)
    {
       tcout << "No spectra loaded, cannot assign plot group numbers."<<std::endl;
       return;
    }
    if (!m_prevGroupRange.first)  m_prevGroupRange.first = 1;
    if (!m_prevGroupRange.second) m_prevGroupRange.second = sz;
    std::pair<size_t,size_t> limits = std::make_pair<size_t,size_t>(1,sz);
    
    string::size_type iSpace = rangesString.find_first_of(' ',0);
    string::size_type prevSpace = 0;
    while(prevSpace != string::npos)
    {
	string subString = rangesString.substr(prevSpace, iSpace-prevSpace);
	std::pair<size_t,size_t> range = 
                XSparse::wildRange(subString, limits, m_prevGroupRange);
        size_t begin = range.first;
        size_t end = range.second;
          
	if (begin > sz || end > sz)
	{
	    std::ostringstream msg;
	    if (begin == end)
	    {
		msg <<'\n'<< begin <<" is out of range of existing spectra";
	    }
	    else
	    {
		msg <<'\n' << begin << '-' << end 
		    << " extends out of range of existing spectra";
	    }   
	    throw XSparse::InvalidRange(msg.str());
	}
          
	// Begin and end are 1-based.
     
	// Check that the bins match up before attempting to group
	// spectra together.
	bool isOKtoGroup = true;
	SpectralData* sd=datasets->lookup(begin);

	for (size_t i=begin + 1; i <= end; ++i)
	{
	    SpectralData* sdata = datasets->lookup(i);

	    if (!sdata->energiesEqual(sd))
	    {
		tcout << "***Warning:  Spectra " << begin << '-' << end
		      << " do not contain the same energy bins and/or channels.\n"
		      << "   They will not be grouped.\n";
		isOKtoGroup = false; 
		break;
	    }
	}

	if (isOKtoGroup)
	{     
	    // Find highest group number prior to spectrum[begin-1].
	    int high = 0;
	    for (size_t i = 0; i < begin-1; ++i)
	    {
		if (datasets->plotGroupNums(i) > high)
		{
		    high = datasets->plotGroupNums(i);
		}
	    }     
	    // Assign spectra begin-1 to end-1 their new group number.
	    ++high;
	    for (size_t i = begin; i <= end; ++i)
	    {
		datasets->setPlotGroupNums(i-1, high);
	    }     
	    // Now correct the later spectra accordingly.
	    datasets->renumberPlotGroups(end+1, high);
	}     
	// prevSpace is actually set here to the next char after the space.
	prevSpace = rangesString.find_first_not_of(' ', iSpace);
	iSpace = rangesString.find_first_of(' ', prevSpace);
    }
  //## end PlotSettings::setPlotGroupNums%4A9D6E0201D8.body
}

void PlotSettings::setIDs (const std::vector<Real>& values)
{
  //## begin PlotSettings::setIDs%4A9D71480306.body preserve=yes
   m_showLineIDs.first = true;
   size_t sz = values.size();
   if (sz)  m_temperature = values[0];
   if (sz > 1)  m_emisLimit = values[1];
   if (sz > 2)  m_redshiftLinesToObs = values[2];
  //## end PlotSettings::setIDs%4A9D71480306.body
}

void PlotSettings::showUserCommands () const
{
  //## begin PlotSettings::showUserCommands%4A9D72EA03D8.body preserve=yes
  if (m_userCommands.empty())
  {
     tcout << "No plot commands have been entered." <<std::endl;
  }
  else
  {
     std::list<string>::const_iterator iC = m_userCommands.begin();
     std::list<string>::const_iterator iCEnd = m_userCommands.end();
     int i = 1;
     while (iC != iCEnd)
     {
        tcout << "   " << i << ": " << *iC << std::endl;
        ++i, ++iC;
     }
  }
  //## end PlotSettings::showUserCommands%4A9D72EA03D8.body
}

void PlotSettings::ungroupAll ()
{
  //## begin PlotSettings::ungroupAll%4A9FEBD40088.body preserve=yes
  using namespace XSContainer;
  
  int sz = datasets->numberOfSpectra();
  for (int i=0; i<sz; ++i)
  {
     datasets->setPlotGroupNums(i, i+1);
  }
  // This call is needed to update datasets' m_numberOfPlotGroups.
  datasets->renumberPlotGroups(1, 0);
  //## end PlotSettings::ungroupAll%4A9FEBD40088.body
}

void PlotSettings::initializeSpectra ()
{
  //## begin PlotSettings::initializeSpectra%4AB8F47F0340.body preserve=yes
  m_spectra.clear();
  
  size_t N (XSContainer::datasets->numberOfSpectra());
  for ( size_t j = 1; j <= N; ++j)
  {
     SpectralData* sp (XSContainer::datasets->lookup(j));       
     if (sp)
     {
        m_spectra.insert(SpecGroup::value_type(sp->plotGroup(),sp));
     }
     else
     {
        throw RedAlert(" data container is corrupted: missing spectra ");
     }   
  }
   
  //## end PlotSettings::initializeSpectra%4AB8F47F0340.body
}

bool PlotSettings::showAddComponent () const
{
  //## begin PlotSettings::showAddComponent%4ADC89AC028D.body preserve=yes
   return (m_showAddComponent.second > 2 || (m_showAddComponent.first &&
                m_showAddComponent.second > 0));
  //## end PlotSettings::showAddComponent%4ADC89AC028D.body
}

bool PlotSettings::showFoldedAddComponent () const
{
  //## begin PlotSettings::showFoldedAddComponent%4B21808203AB.body preserve=yes
   return (m_showAddComponent.second > 3 || (m_showAddComponent.first &&
                m_showAddComponent.second == 2));
  //## end PlotSettings::showFoldedAddComponent%4B21808203AB.body
}

const string& PlotSettings::getUnitID (XaxisMode mode) const
{
  //## begin PlotSettings::getUnitID%4AFDB6120348.body preserve=yes
   // Channel mode is irrelevant in this context.
   if (mode == ENERGY)
      return m_energyUnit.first;
   else if (mode == WAVELENGTH)
      return m_waveUnit.first;
   else
   {
      std::ostringstream oss;
      oss << "Programming Error: Unrecognized mode for unit ID in PlotSettings: "
           << mode;
      throw RedAlert(oss.str());
   }
  //## end PlotSettings::getUnitID%4AFDB6120348.body
}

const string& PlotSettings::getUnitPlotLabel (XaxisMode mode) const
{
  //## begin PlotSettings::getUnitPlotLabel%4AFDB686003D.body preserve=yes
   if (mode == ENERGY)
      return m_energyUnit.second.first;
   else if (mode == WAVELENGTH)
      return m_waveUnit.second.first;
   else
   {
      std::ostringstream oss;
      oss << "Programming Error: Unrecognized mode for unit label in PlotSettings: "
           << mode;
      throw RedAlert(oss.str());
   }
  //## end PlotSettings::getUnitPlotLabel%4AFDB686003D.body
}

Real PlotSettings::getUnitFactor (XaxisMode mode) const
{
  //## begin PlotSettings::getUnitFactor%4AFDB6C40335.body preserve=yes
   if (mode == ENERGY)
      return m_energyUnit.second.second;
   else if (mode == WAVELENGTH)
      return m_waveUnit.second.second;
   else
   {
      std::ostringstream oss;
      oss << "Programming Error: Unrecognized mode for unit factor in PlotSettings: "
           << mode;
      throw RedAlert(oss.str());
   }
  //## end PlotSettings::getUnitFactor%4AFDB6C40335.body
}

string PlotSettings::makeXOptionDependentLabel (string& xLabel) const
{
  //## begin PlotSettings::makeXOptionDependentLabel%4B01C2FC035B.body preserve=yes
   string fullKey = "x:";
   switch (m_xOption)
   {
      default:
      case CHANNELS:
	 fullKey += "channel";
	 break;
      case ENERGY:
	 fullKey += "energy";
	 break;
      case WAVELENGTH:
	 fullKey += "wave";
	 break;
   }
   xLabel = lookupLabelName(fullKey);
   insertUnitLabel(xLabel,false);
   return fullKey;
  //## end PlotSettings::makeXOptionDependentLabel%4B01C2FC035B.body
}

void PlotSettings::insertUnitLabel (string& plotLabel, bool checkPerHz) const
{
  //## begin PlotSettings::insertUnitLabel%4B01C3C6037A.body preserve=yes
   // Assuming CHANNEL mode labels have NO unit placeholders, so this 
   // should do nothing to them.
   const string placeholder("$U");
   const string::size_type len = placeholder.length();
   string curUnitLabel;
   if (m_xOption == WAVELENGTH)
   {
      if (checkPerHz && m_isWavePerHz)
         curUnitLabel = "Hz";
      else
         curUnitLabel = m_waveUnit.second.first;
   }
   else
      curUnitLabel = m_energyUnit.second.first;
   string::size_type iPos = plotLabel.find(placeholder);
   while (iPos != string::npos)
   {
      plotLabel.replace(iPos, len, curUnitLabel);
      // Increment iPos to prevent an infinite loop in the extremely
      // unlikely case that curUnitLabel were to equal placeholder.
      ++iPos;
      iPos = plotLabel.find(placeholder, iPos);
   }
  //## end PlotSettings::insertUnitLabel%4B01C3C6037A.body
}

const string& PlotSettings::lookupLabelName (const string& labelKey) const
{
  //## begin PlotSettings::lookupLabelName%4B01D9E3020A.body preserve=yes
  std::map<string,string>::const_iterator itLabel = m_labelNames.find(labelKey);
  if (itLabel == m_labelNames.end())
  { 
     string err(" no plot label for key: ");
     err += labelKey + "\n";
     throw YellowAlert(err);
  }
  return itLabel->second;
  
  //## end PlotSettings::lookupLabelName%4B01D9E3020A.body
}

//## Get and Set Operations for Class Attributes (implementation)

void PlotSettings::xOption (XaxisMode value)
{
  //## begin PlotSettings::xOption%4A9D634A01CF.set preserve=yes
  m_xOption = value;
  if (m_xOption == CHANNELS)
  {
     SpectralData::chanEngWave(0);
  }
  else if (m_xOption == ENERGY)
  {
     SpectralData::chanEngWave(1);
  }
  else
  {
     SpectralData::chanEngWave(2);
  }
  //## end PlotSettings::xOption%4A9D634A01CF.set
}

// Additional Declarations
  //## begin PlotSettings%4A9D5A2C005E.declarations preserve=yes
  //## end PlotSettings%4A9D5A2C005E.declarations

//## begin module%4A9D59E201C2.epilog preserve=yes
//## end module%4A9D59E201C2.epilog
